/**
 * This class models the tasks that are performed in the garage.
 * 
 * A task has several properties:  1. the duration; 2. the
 * general type: MAINTENANCE, REPAIR, DIAGNOSTIC, STATE_INSPECTION; 
 * 3. the current state.
 * 
 * A task can be in one of three different states: "waiting" to be performed,
 * "in progress," and "finished." These states are modeled internally by two
 * boolean variables inProgress and finished. Since all these states are mutually
 * exclusive, the third state can be inferred from the other two. Initially, the
 * task is in the waiting state.
 * 
 * To represent the progress, we use an integer variable called
 * TimeRemaining, which we decrement in each iteration.
 * 
 */
class Task {
  public static final int MAINTENANCE = 0; // type of the Task
  public static final int REPAIR = 1; // type of the Task
  public static final int DIAGNOSTIC = 2; // type of the Task
  public static final int STATE_INSPECTION = 3; // type of the Task
  
  private int duration; // the duration of the task
  
  private int timeRemaining; // time remaining until completion of the task
  
  private int type; // task type
  
  private boolean finished = false; // is the task completed?
  
  private boolean inProgress = false; // is the task in progress?
  
  /**
   * The costructor sets only some of the fields, we have pre-set finished 
   * and inProgress to false.  Field timeRemaining gets the value of duration.
   * 
   * @param duration -
   *            The duration of the Task
   * @param operation -
   *            the operation performed
   * @param type -
   *            the type of the task
   */
  public Task(int duration, int type) {

    //---------- Implement this method ----------
    
    
  }
  
  /**
   * This method simulates the starting of this task by setting inProgress to
   * true.
   */
  public void start() {

      //---------- Implement this method ----------
    
    
  }
  
  /**
   * This method simulates the execution of this task for 1 time unit by 
   * substracting 1 from timeRemaining.  When timeRemaining becomes 0, then
   * the task leaves state "in progress" and enters the state "finished".
   */
  public void perform() {
    
    //---------- Implement this method ----------
    
    
  }
  
  /**
   * This method tests if the state of this task is "in progress"
   * 
   * @return true if the task is in the state "in progress";
   */
  
  public boolean isInProgress() {

    //---------- Implement this method ----------
    
    
    return false;  // Remove or revise this stub
  }
  
  /**
   * This method tests if the state of this task is "waiting"
   * 
   * @return true if the task is in the state "waiting";
   */
  public boolean isWaiting() {

    //---------- Implement this method ----------
    
    
    return false;  // Remove or revise this stub

  }
  
  /**
   * This method tests if the state of this task is "finished"
   * 
   * @return returns true if the task is in the state "finished";
   */
  public boolean isDone() {

    //---------- Implement this method ----------
    
    
    return false;  // Remove or revise this stub

  }
  
  /**
   * @return Returns field duration, i.e. the duration of this task
   */
  public int getDuration() {
    return duration;
  }
  
  /**
   * @return Returns field type, i.e. the type of this task.
   */
  public int getType() {
    return type;
  }

  /*
   * =A String representation of this Task.
   */
  public String toString() {
    
    //---------- Implement this method ----------
    
    
    return "";  // Remove or revise this stub

  }
}
